VERSION 5.00
Begin VB.Form frmCwbNL 
   Caption         =   "cwbNL API Test"
   ClientHeight    =   4110
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   5775
   LinkTopic       =   "Form1"
   ScaleHeight     =   4110
   ScaleWidth      =   5775
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      BackColor       =   &H80000000&
      Height          =   855
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   6
      TabStop         =   0   'False
      Text            =   "frmCwbNLTst.frx":0000
      Top             =   120
      Width           =   5415
   End
   Begin VB.CommandButton cmdE2A 
      Height          =   855
      Left            =   3480
      Picture         =   "frmCwbNLTst.frx":0006
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   2040
      Width           =   735
   End
   Begin VB.CommandButton cmdA2E 
      Height          =   855
      Left            =   1560
      Picture         =   "frmCwbNLTst.frx":0448
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   2040
      Width           =   735
   End
   Begin VB.TextBox txtEbcdic 
      Height          =   285
      Left            =   120
      ScrollBars      =   1  'Horizontal
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   3600
      Width           =   5415
   End
   Begin VB.TextBox txtAscii 
      Height          =   285
      Left            =   120
      ScrollBars      =   1  'Horizontal
      TabIndex        =   0
      Text            =   "1234567890"
      Top             =   1080
      Width           =   5415
   End
   Begin VB.Label Label2 
      Caption         =   "EBCDIC Data (Hex view of an array of Byte variable)"
      Height          =   255
      Left            =   720
      TabIndex        =   5
      Top             =   3240
      Width           =   4335
   End
   Begin VB.Label Label1 
      Caption         =   "Ascii Text String"
      Height          =   255
      Left            =   2040
      TabIndex        =   4
      Top             =   1440
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAS400Web 
         Caption         =   "AS/400 &Web Sites"
         Begin VB.Menu mnuAS400Kbase 
            Caption         =   "AS/400 &Knowledge Database"
         End
         Begin VB.Menu mnuCA400Home 
            Caption         =   "&Client Access Home Page"
         End
      End
   End
End
Attribute VB_Name = "frmCwbNL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'*********************************************************************
'/* COPYRIGHTS:                                                      */
'/*                                                                  */
'/*   This module contains code made available by IBM Corporation on */
'/* an AS IS basis.  Any one receiving the module is  considered  to */
'/* be  licensed under IBM copyrights to use the IBM-provided source */
'/* code in any way he or  she  deems  fit,  including  copying  it, */
'/* compiling  it,  modifying  it,  and  redistributing  it, with or */
'/* without modifications.  No license  under  any  IBM  patents  or */
'/* patent  applications  is  to  be  implied  from  this  copyright */
'/* license.                                                         */
'/*                                                                  */
'/*   A user of the module should understand that IBM cannot provide */
'/* technical support for the module and will not be responsible for */
'/* any consequences of use of the program.                          */
'/*                                                                  */
'/*   Any notice,  including this one, are not to  be  removed  from */
'/* the module with out the prior written consent of IBM.            */
'/*                                                                  */
'*********************************************************************


Private Sub cmdA2E_Click()
Dim S As String
Dim rc As Long

   'Size the array of Byte to hold the string
   S = txtAscii.Text
   ReDim gabEbcdicData(Len(S) - 1) As Byte

   'Convert the String from Ascii to Ebcdic
   rc = NLAscii2Ebcdic(S, gabEbcdicData)

   'Diplay the EBCDIC Data
   Dim I As Integer
   Dim B As Byte
   On Error GoTo VBANext
   'S = "Length: " & Str(UBound(gabEbcdicData) - LBound(gabEbcdicData) + 1) & "  Data (in hex):"
   S = ""
   For I = LBound(gabEbcdicData) To UBound(gabEbcdicData)
      If (I Mod 4) = 0 Then
         S = S & "  "         'add extra space every 4th byte
      End If
      B = gabEbcdicData(I)
      S = S & Hex(gabEbcdicData(I)) & " "
VBANext:
   Next I
   
   txtEbcdic.Text = S
   txtAscii.Text = ""

   
End Sub

Private Sub cmdE2A_Click()
   Dim S As String
   Dim rc As Long
   Dim NumBytesStored As Long
   Dim NumBytesAvailable As Long
   
   'Convert EBCDIC hex data (from comm trace or program) and store in array
   NumBytesStored = SetEbcdic(txtEbcdic.Text, gabEbcdicData, NumBytesAvailable)
   If NumBytesStored < NumBytesAvailable Then
      ReDim gabEbcdicData(NumBytesAvailable) As Byte
      NumBytesStored = SetEbcdic(txtEbcdic.Text, gabEbcdicData, NumBytesAvailable)
   End If
   
   'Size the String to hold all the data
   S = Space(NumBytesStored)           'Sizeof(gabEbcdicData))
   'Convert to Ascii
   rc = NLEbcdic2Ascii(gabEbcdicData, S, Len(S))
   
   'Display
   txtAscii.Text = S
   txtEbcdic.Text = ""
   

End Sub
Private Function SetEbcdic(sIn As String, Data() As Byte, _
                        Optional ReqLen As Long) As Long
'Returns number of bytes converted and stored in Data()
'Sets ReqLen = Total number of bytes available to be converted.
   Dim S As String
   Dim I As Long
   Dim DataIx As Long
   Dim PosLastChar As Long
   Dim LenData As Long
   Dim TestDigits As String
   
   DataIx = LBound(Data)
   On Error Resume Next
   
   
   I = 1
   Do
      S = Mid$(sIn, I, 1)
      If S = " " Then
         I = I + 1
      Else
         If TestDigitsa(Mid$(sIn, I, 2)) = True Then
            If DataIx <= UBound(Data) Then
               Data(DataIx) = Val("&H" & Mid(sIn, I, 2))
               SetEbcdic = DataIx - LBound(Data) + 1
            End If
            DataIx = DataIx + 1
            I = I + 2
         Else
            I = I + 1
         End If
      End If
   Loop While (I <= Len(sIn))

   ReqLen = DataIx - LBound(Data)
   
End Function
Private Function TestDigitsa(S) As Boolean
   'Verify that 2 character string is a valid hex number
   Dim I As Long
   On Error GoTo TestDigitsFalse
   
   I = Val("&H" & S)
   TestDigitsa = True
   Exit Function
   
TestDigitsFalse:
   TestDigitsa = False
End Function
Private Sub Form_Load()
Dim S As String
 S = "When calling a Client Access API or Automation object that requires " & _
     "a EBCDIC character string, it is safer to pass the data as an array of Byte " & _
     "(Dim abData() as Byte).  Visual Basic stores Strings internally in unicode " & _
     "and will covert unicode to ascii when passing the string to the API.  " & _
     "EBCDIC or binary data may not match to a valid unicode character causing " & _
     "corruption.  " & vbCrLf & _
     "The Data Queue automation object and OCX control require a ""safe array"" " & _
     "(or array of byte) as the  data type for the Key field." & vbCrLf & vbCrLf & _
     "This sample shows how to convert strings from ascii to EBCDIC and vice/versa. "

   Text1.Text = S
End Sub

Private Sub mnuAS400Kbase_Click()
   Call DisplayURL("http://www.as400service.ibm.com/as400/service.html")
End Sub

Private Sub mnuCA400Home_Click()
     Call DisplayURL("http://www.as400.ibm.com/clientaccess")
End Sub

Private Sub mnuExit_Click()
   Unload Me
End Sub

Private Sub txtAscii_KeyDown(KeyCode As Integer, Shift As Integer)
   txtEbcdic.Text = ""
End Sub

Private Sub txtEbcdic_KeyDown(KeyCode As Integer, Shift As Integer)
   txtAscii.Text = ""
End Sub
